import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core/ES2015/IFastItemColumn$1";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Base, Type, Point } from "igniteui-react-core/ES2015/type";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Marker } from "./Marker";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core/ES2015/Clipper";
import { MarkerSeriesView } from "./MarkerSeriesView";
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i(a);
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s(a);
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
    static $t: Type;
}
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
    static $t: Type;
}
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    mz: CategoryFramePreparer;
    protected bf(): SeriesView;
    m3: CategorySeriesView;
    private nc;
    readonly nd: ICategorySeriesInteractionManager;
    ii(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    mu(): CategoryAxisBase;
    ne(): NumericAxisBase;
    protected get_ck(): boolean;
    readonly ck: boolean;
    constructor();
    ac(): void;
    nl: boolean;
    nk: boolean;
    protected ng: boolean;
    protected nf: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected nn(): boolean;
    protected no(): boolean;
    protected oa(a: AssigningCategoryStyleEventArgs): void;
    protected n9(a: AssigningCategoryMarkerStyleEventArgs): void;
    mo(a: number, b: number): any[];
    hl(a: boolean, b: SeriesView): void;
    a8(): SeriesComponentsForView;
    h0(): void;
    nq: boolean;
    protected jh(a: Rect, b: Rect): void;
    m5: CategoryTransitionInMode;
    nm: boolean;
    protected jg(a: Rect, b: Rect): void;
    protected io(a: any, b: string, c: any, d: any): void;
    protected ni(): boolean;
    protected nh(): boolean;
    nt(a: Point): number;
    protected get_c0(): boolean;
    readonly c0: boolean;
    ap(): CategoryAxisBase;
    e4(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    fj(a: Point): any;
    e2(a: Point): number;
    d6(a: Point): number;
    private na;
    private nb;
    protected get_nj(): boolean;
    protected readonly nj: boolean;
    au(a: any, b: Point): HighlightingInfo;
    protected get_cu(): boolean;
    protected readonly cu: boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected ns(): List$1<Marker>;
    protected m9(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected m8(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected m7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    mw: CategoryFrame;
    my: CategoryFrame;
    mv: CategoryFrame;
    mx: CategoryFrame;
    protected m2: CategorySeriesRenderManager;
    protected n6(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected n7(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    private nr(a);
    protected c9(): boolean;
    protected m4(): CategoryTransitionInMode;
    m6: CategoryTransitionSourceFramePreparer;
    protected hm(): void;
    i2(a: boolean): void;
    protected bo(): TransitionInSpeedType;
    protected nu(): number;
    nx(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    n5(a: CategorySeriesView, b: CategoryFrame): void;
    ob(a: CategoryFrame, b: CategorySeriesView): void;
    private oi;
    protected readonly oj: Rect;
    n8(a: CategoryFrame, b: CategorySeriesView): void;
    nv(a: SeriesView): number;
    nw(a: SeriesView): number;
    n4(a: SeriesView): void;
    i3(a: Rect, b: RenderSurface): void;
    oc(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract np(): boolean;
    m0(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static mp(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
    static $t: Type;
}
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    cn: CategorySeries;
    cq: number;
    cp(a: CategoryFrame): boolean;
    cs(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cl: CategoryBucketCalculator;
    cm(): CategoryBucketCalculator;
    co: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    ca(a: (arg1: Marker) => void): void;
    cr(): void;
    static $t: Type;
}
